﻿class MetaSet {
	private var metaName:String;
	private var metaKind:String;
	private var importance:Number;
	private var metaSymbol:MovieClip;
	private var old_x:Number;
	private var old_y:Number;
	private var piledFlag:Boolean;
	private var metaDepth:Number;
	
	private var handle:MovieClip;
	private var mask:MovieClip;
	private var tag:TextField;
	private var tagFormat:TextFormat;
	
	private var DEFAULT_META_POSITION_Y:Number = 335;
	private var DEFAULT_HANDLE_DEPTH:Number = 50;
	private var DEFAULT_HANDLE_TEXT_DEPTH:Number = 150;
	private var DEFAULT_MASK_DEPTH = 500;
	
	function MetaSet(_metaName:String, _metaKind:String ,_importance:Number, _depth:Number) {
		this.metaName = _metaName;
		this.metaKind = _metaKind;
		this.importance = _importance;
		this.metaDepth = _depth;
		this.metaSymbol.swapDepths(this.metaDepth);
		this.metaSymbol = _root.attachMovie("meta_mc", metaKind + this.metaDepth, this.metaDepth);//meta_mcは仮
		this.metaSymbol.metaSet = this;
		
		this.handle = this.metaSymbol.attachMovie("handle_mc", "handle" + this.metaDepth, this.DEFAULT_HANDLE_DEPTH + this.metaDepth);
		
		tagFormat = new TextFormat();
		tag = this.handle.createTextField("tag" + this.metaDepth, this.DEFAULT_HANDLE_TEXT_DEPTH + this.metaDepth, -80, -10, 80, 20);
		{
			tagFormat.font = "handleFont";
			tagFormat.bold = true;
			tagFormat.color = 0xFFFFFF;
			tagFormat.align = "left";
		}
		tag.embedFonts = true;
		tag.setNewTextFormat(tagFormat);
		tag.text = this.getMetaName();
		
		this.mask = this.metaSymbol.attachMovie("meta_mc", "mask" + this.metaDepth, this.DEFAULT_MASK_DEPTH + this.metaDepth);
		this.mask._x = 0;
		this.mask._y = 0;
		
		//testing code
		setMetaSymbolY(DEFAULT_META_POSITION_Y);
		
		//シンボルにテキストを付随させる
		makeTextField();
		
		//実体化したインスタンスをインタラクティブにする
		interactiveMeta();
		
		setHandle();
	}
	
	/*ActionScriptではコンストラクタは一つのクラスに一個しか配置出来ないっぽい？*/
	/*
	function MetaSet(_metaName:String, _metaKind:String ,_importance:Number, initObject:Object) {
		this.metaName = _metaName;
		this.metaKind = _metaKind;
		this.importance = _importance;
		this.metaSymbol = _root.attachMovie("",metaKind + importance, 99, initObject);
	}
	*/
	
	public function setMetaName(metaName:String):Void {
		this.metaName = metaName;
	}
	
	public function getMetaName():String {
		return this.metaName;
	}
	
	public function setMetaKind(metaKind:String):Void {
		this.metaKind = metaKind;
	}
	
	public function getMetaKind():String {
		return this.metaKind;
	}
	
	public function setImportance(importance:Number):Void {
		this.importance = importance;
	}
	
	public function getImportance():Number {
		return this.importance
	}
	
	public function setMetaSymbol(metaSymbol:MovieClip):Void {
		this.metaSymbol = metaSymbol;
	}
	
	public function getMetaSymbol():MovieClip {
		return this.metaSymbol;
	}
	
	public function setOld_x(old_x:Number):Void {
		this.old_x = old_x;
	}
	
	public function getOld_x():Number {
		return this.old_x;
	}
	
	public function setOld_y():Void {
		this.old_y = old_y;
	}
	
	public function getOld_y():Number {
		return this.old_y;
	}
	
	public function setPiledFlag(piledFlag):Void {
		this.piledFlag = piledFlag;
	}
	
	public function getPiledFlag():Boolean {
		return this.piledFlag;
	}
	
	public function setVisible(visibility:Boolean):Void {
		this.metaSymbol._visible = visibility;
	}
	
	public function setHandle():Void {
		this.handle._x = 50;
		this.handle._y = 50;
		//ハンドルの初期角度を45度にする（初期値は90度）
		this.handle._rotation -= 45;
	}
	
	public function handleRotation(piledNum:Number):Void {
		this.handle._rotation = -45;
		
		for(var i:Number = 0; i < piledNum; i++) {//piledNumは重ねる直前の時点で重なってるメタデータの数
			this.handle._rotation += 45;
		}
	}
	
	public function handleAdjust():Void {
		this.handle._rotation -= 45;
	}
	
	public function handleReset():Void {
		this.handle._rotation = -45;
	}
	
	private function setMetaSymbolX(metaX):Void {
		this.metaSymbol._x = metaX;
	}
	
	private function setMetaSymbolY(metaY):Void {
		this.metaSymbol._y = metaY;
	}
	
	public function deleteMetaSet():Void {
		this.setVisible(false);
		this.metaSymbol.removeMovieClip();
	}
	
	private function makeTextField():Void {
		//取っ手につけたテキストフィールドのせいで右に、取っ手テキストフィールドの分だけ右にずれちゃうみたい
		var metaText:TextField = this.mask.createTextField(metaKind + importance + "_txt", metaDepth + 1, 0, 30, this.metaSymbol._width - 80, 20);
		var metaTextFormat:TextFormat = new TextFormat();
		//テキストフォーマット
		{
			metaTextFormat.bold = true;
			metaTextFormat.size = 14;
			metaTextFormat.font = "Arial";
			metaTextFormat.color = 0xFFFFFF;
			metaTextFormat.align = "center";
		}
		metaText.setNewTextFormat(metaTextFormat);
		metaText.text = metaName;
		metaText.selectable = false;
		metaText.autoSize = "center";
		metaText.wordWrap = true;
	}
	
	function interactiveMeta():Void {
		Mouse.addListener(this.metaSymbol);
		
		this.metaSymbol.onPress = function() {
			this.metaSet.old_x = this._x;
			this.metaSet.old_y = this._y;
			this.metaSet.piledFlag = _root.onlyPiledCheck(this.metaSet);
			
			this.onRelease = function() {
				
				delete this.onMouseMove;
			}
			
			this.onMouseMove = function() {
				startDrag(this, false);
				
				this.onRelease = this.onReleaseOutside = function() {
					//if(this._x < -50 || this._x > 450 || this._y < -50 || this._y > 450) {
					if((this._x < -50 || this._x > 450 || this._y < -50 || this._y > 450) && this._y < 470) {//#####testing
					//座標修正をする
						this._x = _root.dropCheckX(this.metaSet, this._x);
						this._y = _root.dropCheckY(this.metaSet, this._y);
					} else if(this._y < this.metaSet.DEFAULT_META_POSITION_Y - 5 && this._y >= -50) {
					//検索領域にメタデータが落とされたら
						_root.removeMetaSet(this.metaSet);
					} else if(this._y >= 470) {//#############################################testing
					//メタデータが画面下に出された場合
						this.metaSet.deleteMetaSet();//出されたメタデータを削除する
					}
		
					//メタデータが検索語に重なったかどうかを判定し、重なっていた場合”検索語に重なっているメタデータのリスト”に登録する
					this.metaSet = _root.piledCheck(this.metaSet);
					
					//ドラッグをやめる
					stopDrag();
				}
				
				delete this.onMouseMove;
			}
		}
	}
	
}