﻿class MetaTerritory {
	
	//メタ領域上の全てのメタデータリスト（人、場所、時）
	private var allMetaList:Array;
	//メタ領域上で現在表示しているメタデータリスト
	private var showingMetaList:Array;
	//新たに抽出されたメタデータリスト
	private var newMetaList:Array;
	
	/**
	  * コンストラクタ
	  */
	function MetaTerritory(result:Result){
		createNewMetaList(result);
		changeForNewMetaList();
	}
	
	/**
	  * 新たに抽出されたメタデータを作成する
	  */
	public function createNewMetaList(result:Result):Void {
		newMetaList = new Array();
		
		for(var i:Number = 0; i < result.getNumber(); i++) {
			newMetaList[i] = new MetaSet(result.getMetaName(i), result.getMetaKind(i), result.getImportance(i), _root.order);
			_root.order++;
		}
	}
	
	/**
	  * 新たに抽出されたメタデータに入れ替える
	  */
	public function changeForNewMetaList():Void{
		if(newMetaList != null){
			//新しく抽出されたメタデータのリストが空じゃないなら、allMetaListの中身に突っ込む
			allMetaList = newMetaList;
			newMetaList = null;
			changeMetaKind("Person");
		}
	}
	
	/**
	  * 表示されるメタデータの種類を入れ替える
	  */
	public function changeMetaKind(metaKind:String):Void{
		showingMetaList = new Array();
		for(var i:Number = 0; i < allMetaList.length; i++){
			if(allMetaList[i].getMetaKind() == metaKind){
				if(!_root.containsMeta(allMetaList[i])) {
					showingMetaList.push(allMetaList[i]);
				}
			}
		}
		updateMetaList();
		for(var j:Number = 0; j < showingMetaList.length; j++) {
			showingMetaList[j].setMetaSymbolX(20 + 120 * j);
		}
	}
	
	/**
	  * メタデータ領域からドラッグされたか調べる
	  */
	public function isDraggedFromMetaTerritory(metaSet:MetaSet):Boolean{
		for(var i:Number = 0; i < showingMetaList.length; i++){
			if(metaSet == showingMetaList[i]){
				return true;
			}
		}
		return false;
	}
	
	/**
	  * メタデータ集合をはずす
	  */
	public function removeMetaSet(metaSet:MetaSet):Void{
		var tempArray:Array = new Array();
		for(var i = 0; i < allMetaList.length; i++){
			if(metaSet != allMetaList[i]){
				tempArray.push(allMetaList[i]);
			} else{
				allMetaList[i].setVisible(false);
			}
		}
		allMetaList = tempArray;
		
		tempArray = new Array();
		for(var i = 0; i < showingMetaList.length; i++){
			if(metaSet != showingMetaList[i]){
				tempArray.push(showingMetaList[i]);
			}
		}
		showingMetaList = tempArray;
		updateMetaList();
	}
	
	/**
	  * メタデータ集合を全て削除する
	  */
	public function deleteAllMetaList():Void {
		for(var i:Number = 0; i < allMetaList.length; i++){
			allMetaList[i].deleteMetaSet();
		}
		
		allMetaList.splice(0);
	}
	
	/**
	  * メタデータリストの表示を更新する
	  * showingMetaListが更新される度に呼ばれる
	  */
	private function updateMetaList():Void{
		for(var i = 0; i < allMetaList.length; i++){
			allMetaList[i].setVisible(false);
		}
		
		for(var i = 0; i < showingMetaList.length; i++){
			//if(!_root.containsMeta(showingMetaList[i])) {
			showingMetaList[i].setVisible(true);
			//}
		}
	}
}