﻿class SearchTerritory {
	private var searchSymbol:MovieClip;//検索語
	private var extractButtonSymbol:MovieClip;//抽出ボタン
	private var metaInSearchTerritory:Array = new Array();//検索領域内にあるメタデータのリスト
	private var metaList:Array = new Array();//検索語に重なっているメタデータのリスト
	
	var META_WIDTH:Number = 100;//検索語の幅（直径）
	var SEARCH_WIDTH:Number = 100;//検索語の高さ（直径）
	
	//コンストラクタ
	function SearchTerritory(searchWord:String) {
		makeSearchSet(searchWord);
	}
	
	//getter/setter
	public function setSearchSymbol(searchSymbol:MovieClip):Void {
		this.searchSymbol = searchSymbol;
	}
	
	public function getSearchSymbol():MovieClip {
		return searchSymbol;
	}
	
	public function setMetaList(metaList:Array):Void {
		this.metaList = metaList;
	}
	
	public function setVisible(visibility:Boolean):Void {
		for(var j:Number = 0; j < metaInSearchTerritory.length; j++) {
			metaInSearchTerritory[j].deleteMetaSet();
		}
	}
	
	public function getMetaList():Array {
		return metaList;
	}
	
	public function getMetaInSearchTerritory():Array {
		return metaInSearchTerritory;
	}
	
	public function updateMetaInSearchTerritory():Void {
		for(var j:Number = 0; j < metaInSearchTerritory.length; j++) {
			metaInSearchTerritory[j].setVisible(true);
		}
	}
	
	/**
	  * 検索語を画面に表示させる
	  */
	private function makeSearchSet(searchWord:String):Void {
		searchSymbol = _root.attachMovie("search_mc", "search_mc", 1000);
		//検索語位置
		{
			searchSymbol._x = 200;
			searchSymbol._y = 100;
		}
		
		var searchText:TextField;
		searchText = searchSymbol.createTextField("search_txt", 1001, 0, 30, searchSymbol._width, 20);
		var searchTextFormat:TextFormat = new TextFormat();
		//テキストフォーム
		{
			searchTextFormat.bold = true;
			searchTextFormat.size = 16;
			searchTextFormat.font = "Arial";
			searchTextFormat.color = 0x000000;
			searchTextFormat.align = "center";
		}
		
		searchText.setNewTextFormat(searchTextFormat);
		searchText.text = searchWord;
		searchText.selectable = false;
		searchText.autoSize = "center";
		searchText.wordWrap = true;
	}
	
	/**
	  * 抽出ボタンを生成する
	  */
	public function makeExtractButton():Void {
		this.extractButtonSymbol = _root.attachMovie("extractButton_mc", "extractButton_mc", 5000);
		//告知位置
		{
			this.extractButtonSymbol._x = 375;
			this.extractButtonSymbol._y = 50;
		}
		
		interactiveInfo();
	}
	
	/**
	  * 抽出ボタンを押せる様にする（インタラクティブにする）
	  */
	public function interactiveInfo():Void {
		Mouse.addListener(this.extractButtonSymbol);
		
		this.extractButtonSymbol.onPress = function() {
			//抽出ボタンがクリックされたとき
			this.onRelease = function() {
				_root.deleteExtractButton();
				_root.deleteAllMetaList();
				_root.makeNewMetaTerritory();
				
				delete this.onMouseMove;
			}
		}
	}
	
	/**
	  * 抽出ボタンを不可視にする（押せなくする）
	  */
	public function deleteExtractButton():Void {
		//this.extractButtonSymbol.removeMovieClip();
		this.extractButtonSymbol._visible = false;
	}
	
	/**
	  * 引数で得たメタデータを検索領域にあるメタデータのリストに追加する
	  */
	public function addToMetaInSearchTerritory(metaSet:MetaSet):Void {
		metaInSearchTerritory.push(metaSet);
	}
	
	/**
	  * メタデータのy座標をold_x（ドラッグする直前のx座標）にする
	  */
	public function dropCheckX(metaSet:MetaSet, metax:Number):Number {
		metax = metaSet.getOld_x();
		
		return metax;
	}
	
	/**
	  * メタデータのy座標をold_y（ドラッグする直前のy座標）にする
	  */
	public function dropCheckY(metaSet:MetaSet, metay:Number):Number {
		metay = metaSet.getOld_y();
		
		return metay;
	}
	
	/**
	  * メタデータを検索語に完全に重ねる（座標を同値にする）
	  */
	public function pileCompletely(metaSet:MetaSet):MetaSet {
		var metaSymbol:MovieClip = metaSet.getMetaSymbol();
		
		var distanceX:Number = searchSymbol._y - metaSymbol._y;
		var distanceY:Number = searchSymbol._x - metaSymbol._x;
		
		//座標を揃える
		metaSymbol._x = searchSymbol._x;
		metaSymbol._y = searchSymbol._y;
		
		return metaSet;
	}
	
	/**
	  * メタデータが検索語に重なったかどうかを判定する
	  */
	public function piledCheck(metaSet:MetaSet):Boolean {
		var metaSymbol:MovieClip = metaSet.getMetaSymbol();
		
		var distance = Math.sqrt(Math.pow((metaSymbol._x - this.searchSymbol._x), 2) + Math.pow((metaSymbol._y - this.searchSymbol._y), 2));//引数で得たメタデータの中心と、検索語の中心との距離
		
		if(distance < META_WIDTH/2 + SEARCH_WIDTH/2) {
		//少しでも重なっている場合
			return true;
		}
		
		return false;
	}
	
	/**
	  * 引数で得たメタデータが、”検索語に重なってるメタデータのリスト”に含まれているかどうかを調べる
	  */
	public function checkPiledList(metaSet:MetaSet):Boolean {
		var i:Number;
		for(i = 0; i < metaList.length; i++) {
			if(metaList[i] == metaSet) {
				return true;
			}
		}
		
		return false;
	}
	
	/**
	  * 検索語に重なってあるメタデータのリストを更新する（追加または削除）
	  */
	public function updatePiledList(metaSet:MetaSet, command:String):Void {
		if(command == "add") {
			if(pushAdmission(metaSet)) {
				metaList.push(metaSet);
			}
			
			/*
			//testing code
			var i:Number;
			for(i = 0; i < metaList.length; i++) {
				trace(metaList[i].getMetaName());
			}
			//testing code end
			*/
			
		} else if(command == "delete") {
			var index:Number;
			for(index = 0; index < metaList.length; index++) {
				if(metaList[index] == metaSet) {
					break;
				}
			}
			metaList.splice(index, 1);
			
			/*
			//testing code
			if(metaList.length != 0) {
				for(index = 0; index < metaList.length; index++) {
					trace(metaList[index].getMetaName());
				} 
			} else {
				trace("ねーよｗｗｗｗ");
			}
			//testing code end
			*/
		}
	}
	
	/**
	  * 引数のメタセットがメタリストの何番目なのかを返す
	  */
	public function myListNum(metaSet:MetaSet):Number {
		var i:Number;
		
		for(i = 0; i < metaList.length; i++) {
			if(metaSet == metaList[i]) {
				break;
			}
		}
		
		return i;
	}
	
	/**
	  * 引数のメタデータが既にメタリストに登録されているかどうかを判定する
	  */
	private function pushAdmission(metaSet:MetaSet):Boolean {
		var admission:Boolean = true;
		
		for(var i:Number = 0; i < metaList.length; i++) {
			if(metaList[i].getMetaName() == metaSet.getMetaName() && metaList[i].getMetaKind() == metaSet.getMetaKind()) {
				admission = false;
				break;
			}
			admission = true;
		}
		
		return admission;
	}
	
	/**
	  * 検索領域にあるメタデータを全て差う所する
	  */
	public function deleteMetaInSearchTerritory():Void {
		for(var i:Number = 0; i < metaInSearchTerritory.length; i++) {
			metaInSearchTerritory[i].deleteMetaSet();
		}
		
		//this.metaList = null;
		//this.metaList = new Array();
		this.metaList.splice(0);
		this.metaInSearchTerritory.splice(0);
	}

}